#include <iostream>
#include <time.h>
#include "controller.h"
#include "channel.h"

void
cthrd_body_(Controller* const ctrl)
{
    time_t t = time(NULL);
    tm* now = localtime(&t);
    int hr = now->tm_hour;
    int min = now->tm_min;
    int sec = now->tm_sec;

    ctrl->fch_->signal_start();    // start fire monitor
    cout << hr << ':' << min << ':' << sec
         << "Controller: fch_->signal_start() " << endl;

    ctrl->pch_->signal_start();    // start power monitor
    t = time(NULL);
    now = localtime(&t);
    hr = now->tm_hour;
    min = now->tm_min;
    sec = now->tm_sec;
    cout << hr << ':' << min << ':' << sec
         << "Controller: pch_->signal_start()" << endl;

    for (;;) {              // loop until stopped by main
        t = time(NULL);
        now = localtime(&t);
        hr = now->tm_hour;
        min = now->tm_min;
        sec = now->tm_sec;
        if (ctrl->sch_->stopped()) {

            cout << hr << ':' << min << ':' << sec
	         << "Controller: stopped by main" << endl;
            cout << hr << ':' << min << ':' << sec
	         << "Controller: stopping monitors" << endl;
            ctrl->fch_->signal_stop();    // stop fire monitor
            ctrl->pch_->signal_stop();    // stop power monitor
            return;
        }
    }
}

Controller::
Controller(channel* fch, channel* pch, channel* sch)
    : fch_(fch), pch_(pch), sch_(sch)
{
    thrd_ = new boost::thread(&cthrd_body_, this);
}

void
Controller::
join()
{
    thrd_->join();
}

