#include <iostream>
#include "firemonitor.h"

using namespace std;

void
fthrd_body_(FireMonitor* const fm)
{
    fm->ch_->wait_start();

    time_t t = time(NULL);
    tm* now = localtime(&t);
    int hr = now->tm_hour;
    int min = now->tm_min;
    int sec = now->tm_sec;
    cout << hr << ':' << min << ':' << sec
         << "    fire monitor started " << endl;

    for (;;) {
        int temp = fm->tsens_->get_temperature();
        if (temp >= fm->tmax_) {
            t = time(NULL);
            now = localtime(&t);
            hr = now->tm_hour;
            min = now->tm_min;
            sec = now->tm_sec;
            cout
                 << hr << ':' << min << ':' << sec
	         << "    FireMonitor: calling fire_emergency() " << endl;
            fm->emgcy_->fire_emergency();

            t = time(NULL);
            now = localtime(&t);
            hr = now->tm_hour;
            min = now->tm_min;
            sec = now->tm_sec;
            cout
                 << hr << ':' << min << ':' << sec
	         << "    FireMonitor: terminating" << endl;
            break;
        }
        if (fm->ch_->stopped()) {
            t = time(NULL);
            now = localtime(&t);
            hr = now->tm_hour;
            min = now->tm_min;
            sec = now->tm_sec;
            cout
                 << hr << ':' << min << ':' << sec
	         << "    FireMonitor: stopped by controller" << endl;
            return;
        }
    }
}

FireMonitor::
FireMonitor(channel* ch, int tmax, TemperatureSensor* tsens, Emergency* emgcy)
            : ch_(ch), tmax_(tmax), tsens_(tsens), emgcy_(emgcy)
{
    thrd_ = new boost::thread(&fthrd_body_, this);
}

void
FireMonitor::
join()
{
    thrd_->join();
}
