#include <boost/thread/thread.hpp>
#include <iostream>
#include <unistd.h>

#include "channel.h"
#include "temperaturesensor.h"
#include "powersensor.h"
#include "controller.h"
#include "firemonitor.h"
#include "powermonitor.h"
#include "emergency.h"

using namespace std;

const int TMAX = 1000;

int
main()
{
    channel fch;             // canale verso fire monitor
    channel pch;             // canale verso power monitor
    channel sch;             // canale verso controller
    TemperatureSensor tsens;
    PowerSensor psens;
    Emergency emgcy;
    Controller ctrl(&fch, &pch, &sch);
    FireMonitor(&fch, TMAX, &tsens, &emgcy);
    PowerMonitor(&pch, &psens, &emgcy);

    sleep(15);  // 15 s
    sch.signal_stop();
    return 0;
}
