#include "powermonitor.h"
#include <iostream>

using namespace std;

void
pthrd_body_(PowerMonitor* const pwr)
{
    pwr->ch_->wait_start();

    time_t t = time(NULL);
    tm* now = localtime(&t);
    int hr = now->tm_hour;
    int min = now->tm_min;
    int sec = now->tm_sec;
    cout << hr << ':' << min << ':' << sec
         << "        power monitor started" << endl;

    for (;;) {
        if (!pwr->psens_->pwr_up()) {

            t = time(NULL);
            now = localtime(&t);
            hr = now->tm_hour;
            min = now->tm_min;
            sec = now->tm_sec;
            cout << hr << ':' << min << ':' << sec
	         << "        PowerMonitor: calling power_emergency()" << endl;
            pwr->emgcy_->power_emergency();

            t = time(NULL);
            now = localtime(&t);
            hr = now->tm_hour;
            min = now->tm_min;
            sec = now->tm_sec;
            cout << hr << ':' << min << ':' << sec
	         << "        PowerMonitor: terminating" << endl;
            break;
        }
        if (pwr->ch_->stopped()) {
            t = time(NULL);
            now = localtime(&t);
            hr = now->tm_hour;
            min = now->tm_min;
            sec = now->tm_sec;
            cout << hr << ':' << min << ':' << sec
	         << "        PowerMonitor: stopped by controller" << endl;
            return;
        }
    }
}

PowerMonitor::
PowerMonitor(channel* ch, PowerSensor* psens, Emergency* emgcy)
             : ch_(ch), psens_(psens), emgcy_(emgcy)
{
    thrd_ = new boost::thread(&pthrd_body_, this);
}

void
PowerMonitor::
join()
{
    thrd_->join();
}
