#ifndef __POWERMONITOR__
#define __POWERMONITOR__

#include <boost/thread/thread.hpp>
#include <boost/thread/mutex.hpp>
#include <boost/thread/condition.hpp>
#include <iostream>

#include "typedefs.h"
#include "channel.h"
#include "emergency.h"
#include "powersensor.h"

class PowerMonitor;
void pthrd_body_(PowerMonitor* const pwr);   // power monitor thread body

class PowerMonitor {
    boost::thread* thrd_;
    channel* ch_;         // signal channel from controller
    PowerSensor* psens_;
    Emergency* emgcy_;
friend
    void pthrd_body_(PowerMonitor* const pwr);   // power monitor thread body
public:
    PowerMonitor(channel* ch, PowerSensor* psens, Emergency* emgcy);
    void join();
};


#endif
