#include <stdlib.h>
#include <time.h>
#include <chrono>
#include <iostream>
#include "temperaturesensor.h"

const int TMAX = 1000;

using namespace std;

static auto
    start = std::chrono::high_resolution_clock::now();    // initial time

TemperatureSensor::
TemperatureSensor()
{
    srand(time(NULL));
}

int
TemperatureSensor::
get_temperature()
{
    auto now = std::chrono::high_resolution_clock::now();    // curremt time
    double
        delta = std::chrono::duration<double, std::milli>(now - start).count();
                                                    // elapsed time in ms

    if (delta < 1000)          // detect fire after 1 s
        return TMAX/2;
    else {
        time_t t = time(NULL);
        tm* now = localtime(&t);
        int hr = now->tm_hour;
        int min = now->tm_min;
        int sec = now->tm_sec;
        cout << hr << ':' << min << ':' << sec
	     << "      TemperatureSensor: fire alert" << endl;
        return 2*TMAX;
    }
}

//int
//TemperatureSensor::
//get_temperature()
//{
//    int i = rand()%10;
//    return temps_[i];
//}
